// 002 u_mail_reader_free
// 06 nov 2019

// -- (C) John COLIBRI 2019
// -- documentation: http://www.jcolibri.com


(*$r+*)

unit u_mail_reader_free;
  Interface
    Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
        , StdCtrls, FileCtrl, ExtCtrls, ComCtrls
        , IdMessage,
  IdAntiFreezeBase, IdAntiFreeze, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdMessageClient, IdPOP3, IdIOHandler,
  IdIOHandlerSocket, IdSSLOpenSSL
   // indy 10 ? , IdAttachmentFile
        ;

    type TForm1=
             class(TForm)
                 command_panel: tPanel;
                 exit_panel: tPanel;
                 exit_: tButton;
                 clear_: tButton;
                 help_: tButton;
                 dir_pagecontrol: tPageControl;
                 dir_tabsheet: tTabSheet;
                 favorites_panel: tPanel;
                 DirectoryListbox1: tDirectoryListbox;
                 dir_file_splitter: tSplitter;
                 file_panel: tPanel;
                 FileListbox1: tFileListbox;
                 bottom_panel: tPanel;
                 left_splitter: tSplitter;
                 display_pagecontrol: tPageControl;
                 display_tabsheet: tTabSheet;
    mail_body_memo_: TMemo;
    TabSheet1: TTabSheet;
    connect_: TButton;
    host_edit_: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    port_edit_: TEdit;
    Label3: TLabel;
    password_edit_: TEdit;
    Label5: TLabel;
    user_edit_: TEdit;
    IdPOP3: TIdPOP3;
    IdAntiFreeze1: TIdAntiFreeze;
    IdMessage1: TIdMessage;
    header_listview_: TListView;
    messages_: TButton;
    IdSSLIOHandlerSocket1: TIdSSLIOHandlerSocket;
    mail_count_label_: TLabel;
    mail_size_label_: TLabel;
    Panel1: TPanel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    from_label_: TLabel;
    to_label_: TLabel;
    cc_label_: TLabel;
    subject_label_: TLabel;
    date_label_: TLabel;
    priority_label_: TLabel;
    receipt_label_: TLabel;
    organization_label_: TLabel;
    attachment_listview_: TListView;
    Memo1: TMemo;
    Splitter1: TSplitter;
    delete_selected_: TButton;
    disconnect_: TButton;
                 Procedure Form1Create(Sender: tObject);
                 Procedure Form1Close(Sender: TObject; var Action: TCloseAction);
                 Procedure exit_Click(Sender: tObject);
                 Procedure clear_Click(Sender: tObject);
                 Procedure help_Click(Sender: tObject);
                 Procedure DirectoryListbox1Change(Sender: tObject);
                 Procedure FileListbox1Click(Sender: tObject);
    procedure connect_Click(Sender: TObject);
    procedure messages_Click(Sender: TObject);
    procedure header_listview_Click(Sender: TObject);
    procedure delete_selected_Click(Sender: TObject);
    procedure disconnect_Click(Sender: TObject);
               private
                 procedure handle_favorite_path_click(p_path, p_extension: String);
               public
             end; // TForm1

    var Form1: tForm1= Nil;

  implementation
    Uses Math
        , u_c_display, u_c_log
        , u_help
        , u_c_favorite_path_list
        , u_exe
        , u_file, u_dir
        , u_c_ini_file
        , u_handle_files_in_dirs

        , u_panel
        , u_strings
        ;

    {$R *.DFM}

    Const k_xxx_path=                'D:\prog\xxx\';
          k_xxx_file_name=           'pascal.pas';
          k_xxx_path_ini_key=        'ini_xxx_path';
          k_xxx_file_name_ini_key=   'ini_xxx_file_name';

    Var g_path:          String= k_xxx_path;
        g_file_name:     String= k_xxx_file_name;
        g_c_ini_file:    c_ini_file= Nil;
        g_file_count:    Integer= 0;
        g_c_favorite_path_list: c_favorite_path_list= Nil;

        g_save_mail_path, g_mail_prefix: String;
        g_mail_suffix: Integer= 0;

    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure my_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      begin
        // -- CAUTION if 2 dirs
        // g_path:= p_path; g_file_name:= p_file_name;
        display_path_and_file;
        // Form1.load_Click(Nil);

        Inc(g_file_count);

        display('  '+ p_file_name);
(*
        with g_c_find_memo do
        begin
          m_save_path:= g_path;
          m_c_memo.Lines.LoadFromFile(g_path+ g_file_name);
          m_c_save_edit.Text:= g_file_name;
        end;
*)
      end; // my_call_back

    // -- events

    procedure TForm1.Form1Create(Sender: TObject);

      procedure _create_mail_path;
        var l_file_index: Integer;
            l_file_name, l_mail_suffix_string: String;
            l_index, l_mail_suffix: Integer;
        begin
          g_save_mail_path:= f_exe_path+ 'save_mails\';

          f_create_path(g_save_mail_path);
          g_mail_prefix:= FormatDateTime('yyyy_mm_dd_hh_nn_', Now);

          g_mail_suffix:= 0;
          with f_c_folder_file_list(g_save_mail_path) do
          begin
            for l_file_index:= 0 to Count- 1 do
            begin
              l_file_name:= Strings[l_file_index];
              if Copy(l_file_name, 1, 17)= g_mail_prefix
                then begin
                    l_mail_suffix_string:= l_file_name;
                    System.Delete(l_mail_suffix_string, 1, 17);
                    l_index:= 1;
                    l_mail_suffix:= f_string_extract_integer_digits(l_mail_suffix_string, l_index);
                    g_mail_suffix:= Max(l_mail_suffix, g_mail_suffix);
                  end;
            end;

            Free;
          end;
        end; // _create_mail_path

      begin // Form1Create
        initialize_display(Memo1.Lines);
        initialize_default_log;
        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_xxx_path_ini_key, k_xxx_path);
          g_file_name:= f_initialize_parameter(k_xxx_file_name_ini_key, k_xxx_file_name);
        end; // with g_c_ini_file
        display_path_and_file;

        // check_name(k_initial_directory);
        // DirectoryListBox1.Directory:= k_initial_directory;

        g_c_favorite_path_list:= c_favorite_path_list.create_favorite_path_list(
            f_exe_path+ 'favorites\'+ f_exe_pure_project_name+ '_favorites.txt',
            favorites_panel, handle_favorite_path_click);

        set_directory_listbox_directory(DirectoryListBox1, g_path);
        with FileListBox1, Items do
          ItemIndex:= IndexOf(g_file_name);

        _create_mail_path;
      end; // Form1Create

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        header_listview_.Items.Clear;
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.Form1Close(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // Form1Close

    // -- call handler

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_xxx_path_ini_key, g_path);
        // display_path_and_file;
      end; // DirectoryListBox1Change

    procedure TForm1.FileListBox1Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      // var l_path, l_name: String;
      begin
        // l_path:= DirectoryListBox1.Directory;
        with FileListbox1 do
          g_file_name:= Items[ItemIndex];
        // Form1.load_Click(Nil);
        g_c_ini_file.set_parameter(k_xxx_file_name_ini_key, g_file_name);

        g_file_count:= 0;
        my_call_back(0, g_path, g_file_name, Nil);
        // TODO update the ini 
        g_c_ini_file.save_to_default_file;
      end; // FileListBox1Click

    procedure handle_the_files(p_dir_handling_types: t_dir_handling_types);
      var l_extension: String;
          l_path: String;
      begin
(*
        l_path:= f_without_ending_slash(k_initial_directory);
        l_extension:= '.HTML';

        with DirectoryListBox1 do
          l_path:= f_without_ending_slash(GetItemPath(ItemIndex));
        l_extension:= FilterComboBox1.Filter;
*)
        l_path:= f_without_ending_slash(g_path);

        l_extension:= Form1.FileListBox1.Mask;
        Delete(l_extension, 1, 1);
        l_extension:= UpperCase(l_extension);

        display_line;
        display('handle_non_rec of '+ l_path+ ' '+ l_extension);
        display_line;
        g_file_count:= 0;

        handle_all_files_recursive(1, l_path, l_extension,
            p_dir_handling_types, my_call_back, Nil);

        display_line;
        display(Format('FINISHED %3d ', [g_file_count]));
      end; // handle_the_files

    procedure tForm1.handle_favorite_path_click(p_path, p_extension: String);
      begin
        set_directory_listbox_directory(DirectoryListbox1, p_path);
      end; // handle_favorite_path_click

    procedure TForm1.help_Click(Sender: TObject);
      begin
        display_help;
      end; // help_Click

    procedure TForm1.connect_Click(Sender: TObject);
      begin
        set_panel_color(exit_panel, clRed);
        with IdPop3 do
        begin
          Host:= host_edit_.Text;
          Port:= StrToInt(port_edit_.Text);
          UserName:= user_edit_.Text;
          Password:= password_edit_.Text;

          Connect;

          if Connected
            then begin
                display('connected');
                set_panel_color(exit_panel, clLime);
              end
            else display('*** not_connected');
        end; // with IdPop3
      end; // connect_Click

    procedure TForm1.messages_Click(Sender: TObject);
      var l_mail_count, l_mail_index: Integer;
      begin
        with idpop3 do
        begin
          header_listview_.Items.Clear;

          if not Connected
            then Exit;

          l_mail_count:= CheckMessages;

          mail_count_label_.Caption:= IntToStr(l_mail_count);
          mail_size_label_.Caption:= IntToStr(RetrieveMailBoxSize div 1024)+ ' K';

          for l_mail_index := 1 To l_mail_count Do
          begin
            RetrieveHeader(l_mail_index, IdMessage1);
            with header_listview_.Items.Add do
            begin
              Caption := idMessage1.Subject;
              SubItems.Add(idMessage1.From.Text);
              SubItems.Add(DateToStr(idMessage1.Date));
              SubItems.Add(idMessage1.Uid);

              SubItems.Add(IntToStr(RetrieveMsgSize(l_mail_index)));
            end; // with header_listview_
          end; // for l_mail_index
        end; // with idpop3
      end; // messages_Click

    procedure TForm1.header_listview_Click(Sender: TObject);
      var l_attachment_count, l_attachment_index: Integer;
          l_save_mail_file_name: String;
      begin
        with idpop3 do
        begin
          Retrieve(1+ header_listview_.Selected.Index, IdMessage1);

          from_label_.Caption := IdMessage1.From.Text;
          to_label_.Caption := IdMessage1.Recipients.EmailAddresses;
          cc_label_.Caption := IdMessage1.CCList.EMailAddresses;
          subject_label_.Caption := IdMessage1.Subject;
          date_label_.Caption := FormatDateTime('dd mmm yyyy hh:mm:ss', IdMessage1.Date);
          priority_label_.Caption := IntToStr(Ord(IdMessage1.Priority) + 1);
          receipt_label_.Caption := IdMessage1.ReceiptRecipient.Text;
          organization_label_.Caption := IdMessage1.Organization;

          Inc(g_mail_suffix);
          l_save_mail_file_name:= g_save_mail_path+ g_mail_prefix+ f_zero_prefixed_string(g_mail_suffix, 3);
          idMessage1.SaveToFile(l_save_mail_file_name+ '.txt');

          mail_body_memo_.Lines.Clear;

          l_attachment_count:= IdMessage1.MessageParts.Count;
          for l_attachment_index := 0 to l_attachment_count- 1 do
            // tIdAttachmentFile for indy 10
            if IdMessage1.MessageParts.Items[l_attachment_index] is TIdAttachment
              then // general attachment
                with attachment_listview_.Items.Add do
                begin
                  Caption := TIdAttachment(IdMessage1.MessageParts.Items[l_attachment_index]).Filename;
                  SubItems.Add(TIdAttachment(IdMessage1.MessageParts.Items[l_attachment_index]).ContentType);
                  mail_body_memo_.Lines.SaveToFile(f_normal_or_unique_file_name(l_save_mail_file_name)+ Caption);
                end
              else // body text
                if IdMessage1.MessageParts.Items[l_attachment_index] is TIdText
                  then begin
                      mail_body_memo_.Lines.Assign(TIdText(IdMessage1.MessageParts.Items[l_attachment_index]).Body);
                      mail_body_memo_.Lines.SaveToFile(f_normal_or_unique_file_name(l_save_mail_file_name)+ '_txt.txt');
                   end
                 else display(IdMessage1.MessageParts.Items[l_attachment_index].ClassName);

          if IdMessage1.Body.Text<> ''
            then mail_body_memo_.Lines.Text:= mail_body_memo_.Lines.Text+ IdMessage1.Body.Text;
        end; // with idpop3

      end; // header_listview_Click

    procedure TForm1.delete_selected_Click(Sender: TObject);
      var l_list_index: Integer;
      begin
        ShowMessage('uncomment exit');
        Exit;
        
        with header_listview_ do
          for l_list_index:= 0 to Items.Count- 1 do
            if Items[l_list_index].Selected
              then begin
                  IdPop3.Delete(1+ l_list_index);
                end;
      end; // delete_selected_Click

    procedure TForm1.disconnect_Click(Sender: TObject);
      begin
        IdPop3.Disconnect;
      end; // disconnect_Click

end. // mail_reader_free

