// 001 u_c_session_list
// 04 mar 00

(*
under exe, save the favorites with   abrev, dir, ext (= for .txt)
 - was developped for coliget
 - for p_xxx.exe, the file is xxx_favorites.txt
 - path  exe\favorites\
 - the format of a line is
   |ed                  c:\prog\ed\data\                                      .ed
 - the file MUST exist for the component creation


uses
      , u_c_favorite_path_list, u_exe

tForm1
    procedure handle_favorite_path_click(p_path, p_extension: String);

globals
        g_c_favorite_path_list: c_favorite_path_list= Nil;

form create
    var l_favorites_full_file_name: String;
    
        l_favorites_full_file_name:= f_exe_path+ 'favorites\'+ f_exe_pure_project_name+ '_favorites.txt';
        if not FileExists(l_favorites_full_file_name)
          then check_name(l_favorites_full_file_name)
          else g_c_favorite_path_list:= c_favorite_path_list.create_favorite_path_list(
            l_favorites_full_file_name,
            favorites_panel_, handle_favorite_path_click);

    procedure tForm1.handle_favorite_path_click(p_path, p_extension: String);
      begin
        set_directory_listbox_directory(DirectoryListBox1, p_path);
      end; // handle_favorite_path_click


*)

(*$r+*)

unit u_c_favorite_path_list;
  interface
    uses Classes, StdCtrls, ExtCtrls, u_c_basic_object;

    type c_favorite_path= // one "favorite_path"
             Class(c_basic_object)
               // -- m_name: the displayed name in the memos
               m_path, m_parameter: String;

               Constructor create_favorite_path(p_name, p_path, p_parameter: String);
               function f_display_favorite_path: String;
               function f_c_self: c_favorite_path;
               Destructor Destroy; Override;
             end; // c_favorite_path

         t_po_notify_favorite_click= procedure(p_path, p_parameter: String) of Object;

         c_favorite_path_list= // "favorite_path" list
             Class(c_basic_object)
               // -- m_name: the full file name

               m_c_favorite_path_list: tStringList;
               m_c_panel_ref: tPanel;
               m_memo_count: Integer;
               m_c_list_box: tListBox;

               m_c_on_listbox_click: t_po_notify_favorite_click;

               Constructor create_favorite_path_list(p_name: String;
                   p_c_panel_ref: tPanel;
                   p_c_on_listbox_click: t_po_notify_favorite_click);

               function f_favorite_path_count: Integer;
               function f_c_favorite_path(p_favorite_path_index: Integer): c_favorite_path;
               function f_index_of(p_favorite_path_name: String): Integer;
               function f_c_find_by_favorite_path(p_favorite_path_name: String): c_favorite_path;
               procedure add_favorite_path(p_favorite_path_name: String; p_c_favorite_path: c_favorite_path);
               function f_c_add_favorite_path(p_favorite_path_name, p_path, p_parameter: String): c_favorite_path;
               function f_c_add_unique_favorite_path(p_favorite_path_name, p_path, p_parameter: String): c_favorite_path;
               function f_c_delete_favorite_path(p_favorite_path_index: Integer): c_favorite_path;

               procedure display_favorite_path_list;

               procedure handle_favorite_listbox_click(p_c_sender: tObject);
               procedure load_from_file(p_full_file_name: String);
               procedure create_listboxes;

               Destructor Destroy; Override;
             end; // c_favorite_path_list

  implementation
    uses SysUtils, Controls, u_c_display
        , u_strings
        ;

    // -- c_favorite_path

    Constructor c_favorite_path.create_favorite_path(p_name, p_path, p_parameter: String);
      begin
        Inherited create_basic_object(p_name);

        m_path:= p_path;
        m_parameter:= p_parameter;
        if m_parameter= '='
          then m_parameter:= 'txt';
      end; // create_favorite_path

    function c_favorite_path.f_display_favorite_path: String;
      begin
        Result:= Format('%-10s ', [m_name])+ m_path+ ' ['+ m_parameter+ ']';
      end; // f_display_favorite_path

    function c_favorite_path.f_c_self: c_favorite_path;
      begin
        Result:= Self;
      end; // f_c_self

    Destructor c_favorite_path.Destroy;
      begin
        InHerited;
      end; // Destroy

    // -- c_favorite_path_list

    Constructor c_favorite_path_list.create_favorite_path_list(p_name: String;
        p_c_panel_ref: tPanel;
        p_c_on_listbox_click: t_po_notify_favorite_click);
      begin
        Inherited create_basic_object(p_name);

        m_c_panel_ref:= p_c_panel_ref;

        m_c_favorite_path_list:= tStringList.Create;
        if FileExists(m_name)
          then begin
              load_from_file(m_name);
              create_listboxes;
            end
          else display('*** no_favorites '+ m_name);  
        m_c_on_listbox_click:= p_c_on_listbox_click;
      end; // create_favorite_path_line

    function c_favorite_path_list.f_favorite_path_count: Integer;
      begin
        Result:= m_c_favorite_path_list.Count;
      end; // f_favorite_path_count

    function c_favorite_path_list.f_c_favorite_path(p_favorite_path_index: Integer): c_favorite_path;
      begin
        Result:= c_favorite_path(m_c_favorite_path_list.Objects[p_favorite_path_index]);
      end; //  f_c_favorite_path

    function c_favorite_path_list.f_index_of(p_favorite_path_name: String): Integer;
      begin
        Result:= m_c_favorite_path_list.IndexOf(p_favorite_path_name);
      end; // f_index_of

    function c_favorite_path_list.f_c_find_by_favorite_path(p_favorite_path_name: String): c_favorite_path;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_favorite_path_name);
        if l_index_of< 0
          then Result:= Nil
          else Result:= c_favorite_path(m_c_favorite_path_list.Objects[l_index_of]);
      end; // f_c_find_by_name

    procedure c_favorite_path_list.add_favorite_path(p_favorite_path_name: String; p_c_favorite_path: c_favorite_path);
      begin
        m_c_favorite_path_list.AddObject(p_favorite_path_name, p_c_favorite_path);
      end; // add_favorite_path

    function c_favorite_path_list.f_c_add_favorite_path(p_favorite_path_name, p_path, p_parameter: String): c_favorite_path;
      begin
        Result:= c_favorite_path.create_favorite_path(p_favorite_path_name, p_path, p_parameter);
        add_favorite_path(p_favorite_path_name, Result);
      end; // f_c_add_favorite_path

    function c_favorite_path_list.f_c_add_unique_favorite_path(p_favorite_path_name, p_path, p_parameter: String): c_favorite_path;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_favorite_path_name);
        if l_index_of>= 0
          then Result:= f_c_favorite_path(l_index_of)
          else Result:= f_c_add_favorite_path(p_favorite_path_name, p_path, p_parameter);
      end; // f_c_add_unique_favorite_path

    procedure c_favorite_path_list.display_favorite_path_list;
      var l_favorite_path_index: Integer;
      begin
        display(m_name+ ' '+ IntToStr(f_favorite_path_count));

        for l_favorite_path_index:= 0 to f_favorite_path_count- 1 do
          display(f_c_favorite_path(l_favorite_path_index).f_display_favorite_path);
      end; // display_favorite_path_list

    function c_favorite_path_list.f_c_delete_favorite_path(p_favorite_path_index: Integer): c_favorite_path;
      begin
        Result:= f_c_favorite_path(p_favorite_path_index);
        m_c_favorite_path_list.Delete(p_favorite_path_index);
      end; // f_c_delete_favorite_path

    procedure c_favorite_path_list.load_from_file(p_full_file_name: String);
      var l_list_index: Integer;
          l_the_line: String;
          l_index: integer;
          l_name, l_path_name, l_parameter: String;
          // l_caption, 
      begin
        m_memo_count:= 1;
        with tStringList.Create do
        begin
          LoadFromFile(p_full_file_name);

          for l_list_index:= 0 to Count- 1 do
          begin
            l_the_line:= Strings[l_list_index];
            // display(l_the_line);
            if Trim(l_the_line)= ''
              then begin
                  Inc(m_memo_count);
                end
              else begin
                  l_index:= 1;
                  l_name:= f_string_extract_non_blank(l_the_line, l_index);
                  l_path_name:= f_string_extract_non_blank(l_the_line, l_index);
                  l_parameter:= f_string_extract_non_blank(l_the_line, l_index);

                  f_c_add_favorite_path(l_name, l_path_name, l_parameter);
                end;
          end; // while l_list_index

          Free;
        end; // with tStringList
      end; // load_from_file

    procedure c_favorite_path_list.handle_favorite_listbox_click(p_c_sender: tObject);
      var l_c_favorite_path: c_favorite_path;
      begin
        with m_c_list_box do
          l_c_favorite_path:= f_c_find_by_favorite_path(Items[ItemIndex]);
        display(l_c_favorite_path.f_display_favorite_path);

        if Assigned(m_c_on_listbox_click)
         then
           with l_c_favorite_path do
             m_c_on_listbox_click(m_path, m_parameter);
      end; // handle_favorite_listbox_click

    procedure c_favorite_path_list.create_listboxes;

      function f_c_listbox(p_left, p_top, p_with, p_height: Integer): tListBox;
        begin
          Result:= tListBox.Create(Nil);
          with Result Do
          begin
            Name:= 'mylistbox';
            Parent:= m_c_panel_ref;
            Align:= alClient;
            OnClick:= handle_favorite_listbox_click;
          end; // with Result
        end; // f_c_listbox

      var // l_c_list_box: tListBox;
          l_favorite_path_index: Integer;

      begin
        m_c_list_box:= f_c_listbox(0, 0, 0, 0);

        for l_favorite_path_index:= 0 to f_favorite_path_count- 1 do
          with f_c_favorite_path(l_favorite_path_index) do
          begin
            m_c_list_box.Items.Add(m_name);
          end;
      end; // create_listboxes

    Destructor c_favorite_path_list.Destroy;
      var l_favorite_path_index: Integer;
      begin
        for l_favorite_path_index:= 0 to f_favorite_path_count- 1 do
          f_c_favorite_path(l_favorite_path_index).Free;
        m_c_favorite_path_list.Free;

        Inherited;
      end; // Destroy

    begin // u_c_favorite_path_list
    end. // u_c_favorite_path_list
